// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package observations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_models"
)

// NewPostObservationsParams creates a new PostObservationsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostObservationsParams() *PostObservationsParams {
	return &PostObservationsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostObservationsParamsWithTimeout creates a new PostObservationsParams object
// with the ability to set a timeout on a request.
func NewPostObservationsParamsWithTimeout(timeout time.Duration) *PostObservationsParams {
	return &PostObservationsParams{
		timeout: timeout,
	}
}

// NewPostObservationsParamsWithContext creates a new PostObservationsParams object
// with the ability to set a context for a request.
func NewPostObservationsParamsWithContext(ctx context.Context) *PostObservationsParams {
	return &PostObservationsParams{
		Context: ctx,
	}
}

// NewPostObservationsParamsWithHTTPClient creates a new PostObservationsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostObservationsParamsWithHTTPClient(client *http.Client) *PostObservationsParams {
	return &PostObservationsParams{
		HTTPClient: client,
	}
}

/*
PostObservationsParams contains all the parameters to send to the API endpoint

	for the post observations operation.

	Typically these are written to a http.Request.
*/
type PostObservationsParams struct {

	/* AccountRequest.

	   A request with an array of Observation Objects
	*/
	AccountRequest *sfgate_models.ObservationRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post observations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostObservationsParams) WithDefaults() *PostObservationsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post observations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostObservationsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post observations params
func (o *PostObservationsParams) WithTimeout(timeout time.Duration) *PostObservationsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post observations params
func (o *PostObservationsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post observations params
func (o *PostObservationsParams) WithContext(ctx context.Context) *PostObservationsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post observations params
func (o *PostObservationsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post observations params
func (o *PostObservationsParams) WithHTTPClient(client *http.Client) *PostObservationsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post observations params
func (o *PostObservationsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountRequest adds the accountRequest to the post observations params
func (o *PostObservationsParams) WithAccountRequest(accountRequest *sfgate_models.ObservationRequest) *PostObservationsParams {
	o.SetAccountRequest(accountRequest)
	return o
}

// SetAccountRequest adds the accountRequest to the post observations params
func (o *PostObservationsParams) SetAccountRequest(accountRequest *sfgate_models.ObservationRequest) {
	o.AccountRequest = accountRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostObservationsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.AccountRequest != nil {
		if err := r.SetBodyParam(o.AccountRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
